IoT Device Health in JavaScript

Using ApexCharts with JavaScript

This IoT Device Health example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
// A rack-temperature fleet: 60 devices, one day of 30-minute readings each.
// The grid VIRTUALIZES (`trellis.virtualize: true`): every cell and header
// exists up front (page height never shifts), but only the panels near the
// viewport are live charts. Scroll: panels mount as they approach and are
// destroyed as they leave, keeping the DOM small; a zoom set anywhere rides
// along and is restored when a panel scrolls back in.
//
// The y scale is SHARED, so the one overheating rack is visible from across
// the room, and the dense traces paint on the canvas renderer.
//
// Deterministic walks so the e2e snapshot is stable.
function mulberry32(seed) {
  return function () {
    seed |= 0
    seed = (seed + 0x6d2b79f5) | 0
    var t = Math.imul(seed ^ (seed >>> 15), 1 | seed)
    t = (t + Math.imul(t ^ (t >>> 7), 61 | t)) ^ t
    return ((t ^ (t >>> 14)) >>> 0) / 4294967296
  }
}

function dayOfReadings(seed, base, drift) {
  var rand = mulberry32(seed)
  var out = []
  var ts = new Date('01 Jan 2025').getTime()
  var val = base
  for (var i = 0; i < 48; i++) {
    val += (rand() - 0.5) * 1.6 + drift
    out.push([ts, Math.round(val * 10) / 10])
    ts += 1800000 // 30 minutes
  }
  return out
}

var deviceSeries = []
for (var d = 1; d <= 60; d++) {
  var id = 'RACK-' + (d < 10 ? '0' + d : d)
  // Most racks idle in the low 40s; RACK-27 is running away.
  var hot = d === 27
  deviceSeries.push({
    name: 'Temp',
    device: id,
    data: dayOfReadings(d * 13, hot ? 68 : 40 + (d % 7), hot ? 0.35 : 0),
  })
}

var options = {
  series: deviceSeries,
  chart: {
    id: 'deviceHealthTrellis',
    type: 'line',
    renderer: 'canvas',
  },
  trellis: {
    by: 'device',
    virtualize: true,
    panelHeight: 150,
    minPanelWidth: 240,
    gap: 12,
  },
  colors: ['#059669'],
  stroke: {
    width: 2,
    curve: 'straight',
  },
  xaxis: {
    type: 'datetime',
  },
  yaxis: {
    labels: {
      formatter: function (val) {
        return Math.round(val) + '°C'
      },
    },
  },
  dataLabels: {
    enabled: false,
  },
  tooltip: {
    x: {
      format: 'HH:mm',
    },
  },
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

IoT Device Health in React

Using ApexCharts with React

This IoT Device Health example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import './styles.css'

import 'apexcharts/features/renderer-canvas'
import 'apexcharts/features/trellis'

// A rack-temperature fleet: 60 devices, one day of 30-minute readings each.
// The grid VIRTUALIZES (`trellis.virtualize: true`): every cell and header
// exists up front (page height never shifts), but only the panels near the
// viewport are live charts. Scroll: panels mount as they approach and are
// destroyed as they leave, keeping the DOM small; a zoom set anywhere rides
// along and is restored when a panel scrolls back in.
//
// The y scale is SHARED, so the one overheating rack is visible from across
// the room, and the dense traces paint on the canvas renderer.
//
// Deterministic walks so the e2e snapshot is stable.
function mulberry32(seed) {
  return function () {
    seed |= 0
    seed = (seed + 0x6d2b79f5) | 0
    var t = Math.imul(seed ^ (seed >>> 15), 1 | seed)
    t = (t + Math.imul(t ^ (t >>> 7), 61 | t)) ^ t
    return ((t ^ (t >>> 14)) >>> 0) / 4294967296
  }
}

function dayOfReadings(seed, base, drift) {
  var rand = mulberry32(seed)
  var out = []
  var ts = new Date('01 Jan 2025').getTime()
  var val = base
  for (var i = 0; i < 48; i++) {
    val += (rand() - 0.5) * 1.6 + drift
    out.push([ts, Math.round(val * 10) / 10])
    ts += 1800000 // 30 minutes
  }
  return out
}

var deviceSeries = []
for (var d = 1; d <= 60; d++) {
  var id = 'RACK-' + (d < 10 ? '0' + d : d)
  // Most racks idle in the low 40s; RACK-27 is running away.
  var hot = d === 27
  deviceSeries.push({
    name: 'Temp',
    device: id,
    data: dayOfReadings(d * 13, hot ? 68 : 40 + (d % 7), hot ? 0.35 : 0),
  })
}

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: deviceSeries,
    options: {
      chart: {
        id: 'deviceHealthTrellis',
        type: 'line',
        renderer: 'canvas',
      },
      trellis: {
        by: 'device',
        virtualize: true,
        panelHeight: 150,
        minPanelWidth: 240,
        gap: 12,
      },
      colors: ['#059669'],
      stroke: {
        width: 2,
        curve: 'straight',
      },
      xaxis: {
        type: 'datetime',
      },
      yaxis: {
        labels: {
          formatter: function (val) {
            return Math.round(val) + '°C'
          },
        },
      },
      dataLabels: {
        enabled: false,
      },
      tooltip: {
        x: {
          format: 'HH:mm',
        },
      },
    },
  })

  return (
    <div>
      <div className="wrap">
        <h1>Device health, one panel per rack</h1>
        <p className="lead">
          Sixty racks, one shared temperature scale, and only the panels you can
          see are live charts. Scroll the grid: panels mount as they approach
          the viewport and unmount as they leave, so the page stays light at any
          fleet size. RACK-27 is the one to worry about.
        </p>

        <div className="chart-wrap">
          <div id="chart">
            <ReactApexChart
              options={state.options}
              series={state.series}
              type="line"
            />
          </div>
        </div>

        <div className="note">
          This grid is <strong>virtualized</strong>:{' '}
          <code>trellis.virtualize: true</code> mounts only the panels
          intersecting the viewport (plus one row of look-ahead). Every cell
          keeps its header and a fixed-height skeleton, so page height and
          scroll position never shift; a panel that scrolls out is destroyed
          with its view stashed, and scrolling back restores it, zoom window
          included. Above 64 panels this happens automatically (
          <code>virtualize: 'auto'</code>). The shared y scale is what makes the
          hot rack obvious, the traces paint on the canvas renderer (
          <code>chart.renderer: 'canvas'</code>), and mount animations default
          off above 16 panels. Trellis is a premium feature; without a license
          it renders with a trial watermark.
        </div>
      </div>
    </div>
  )
}

export default ApexChart

IoT Device Health in Angular

Using ApexCharts with Angular

This IoT Device Health example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  private mulberry32 = (seed: any): any => {
        return function () {
          seed |= 0
          seed = (seed + 0x6d2b79f5) | 0
          var t = Math.imul(seed ^ (seed >>> 15), 1 | seed)
          t = (t + Math.imul(t ^ (t >>> 7), 61 | t)) ^ t
          return ((t ^ (t >>> 14)) >>> 0) / 4294967296
        }
      };

  private dayOfReadings = (seed: any, base: any, drift: any): any => {
        var rand = this.mulberry32(seed)
        var out = []
        var ts = new Date('01 Jan 2025').getTime()
        var val = base
        for (var i = 0; i < 48; i++) {
          val += (rand() - 0.5) * 1.6 + drift
          out.push([ts, Math.round(val * 10) / 10])
          ts += 1800000 // 30 minutes
        }
        return out
      };

  private deviceSeries: any = [];

  public chartOptions: Partial<ChartOptions> = {
          series: this.deviceSeries,
          chart: {
            id: 'deviceHealthTrellis',
            type: 'line',
            renderer: 'canvas',
          },
          trellis: {
            by: 'device',
            virtualize: true,
            panelHeight: 150,
            minPanelWidth: 240,
            gap: 12,
          },
          colors: ['#059669'],
          stroke: {
            width: 2,
            curve: 'straight',
          },
          xaxis: {
            type: 'datetime',
          },
          yaxis: {
            labels: {
              formatter: (val) => {
                return Math.round(val) + '°C'
              },
            },
          },
          dataLabels: {
            enabled: false,
          },
          tooltip: {
            x: {
              format: 'HH:mm',
            },
          },
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
    for (var d = 1; d <= 60; d++) {
          var id = 'RACK-' + (d < 10 ? '0' + d : d)
          // Most racks idle in the low 40s; RACK-27 is running away.
          var hot = d === 27
          this.deviceSeries.push({
            name: 'Temp',
            device: id,
            data: this.dayOfReadings(d * 13, hot ? 68 : 40 + (d % 7), hot ? 0.35 : 0),
          })
        }
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}

IoT Device Health in Vue

Using ApexCharts with Vue

This IoT Device Health example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div class="wrap">
      <h1>Device health, one panel per rack</h1>
      <p class="lead">
        Sixty racks, one shared temperature scale, and only the panels you can
        see are live charts. Scroll the grid: panels mount as they approach the
        viewport and unmount as they leave, so the page stays light at any fleet
        size. RACK-27 is the one to worry about.
      </p>

      <div class="chart-wrap">
        <div id="chart">
          <apexchart
            type="line"
            :options="chartOptions"
            :series="series"
          ></apexchart>
        </div>
      </div>

      <div class="note">
        This grid is <strong>virtualized</strong>:
        <code>trellis.virtualize: true</code> mounts only the panels
        intersecting the viewport (plus one row of look-ahead). Every cell keeps
        its header and a fixed-height skeleton, so page height and scroll
        position never shift; a panel that scrolls out is destroyed with its
        view stashed, and scrolling back restores it, zoom window included.
        Above 64 panels this happens automatically (<code
          >virtualize: 'auto'</code
        >). The shared y scale is what makes the hot rack obvious, the traces
        paint on the canvas renderer (<code>chart.renderer: 'canvas'</code>),
        and mount animations default off above 16 panels. Trellis is a premium
        feature; without a license it renders with a trial watermark.
      </div>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'

import 'apexcharts/features/renderer-canvas'
import 'apexcharts/features/trellis'

// A rack-temperature fleet: 60 devices, one day of 30-minute readings each.
// The grid VIRTUALIZES (`trellis.virtualize: true`): every cell and header
// exists up front (page height never shifts), but only the panels near the
// viewport are live charts. Scroll: panels mount as they approach and are
// destroyed as they leave, keeping the DOM small; a zoom set anywhere rides
// along and is restored when a panel scrolls back in.
//
// The y scale is SHARED, so the one overheating rack is visible from across
// the room, and the dense traces paint on the canvas renderer.
//
// Deterministic walks so the e2e snapshot is stable.
function mulberry32(seed) {
  return function () {
    seed |= 0
    seed = (seed + 0x6d2b79f5) | 0
    var t = Math.imul(seed ^ (seed >>> 15), 1 | seed)
    t = (t + Math.imul(t ^ (t >>> 7), 61 | t)) ^ t
    return ((t ^ (t >>> 14)) >>> 0) / 4294967296
  }
}

function dayOfReadings(seed, base, drift) {
  var rand = mulberry32(seed)
  var out = []
  var ts = new Date('01 Jan 2025').getTime()
  var val = base
  for (var i = 0; i < 48; i++) {
    val += (rand() - 0.5) * 1.6 + drift
    out.push([ts, Math.round(val * 10) / 10])
    ts += 1800000 // 30 minutes
  }
  return out
}

var deviceSeries = []
for (var d = 1; d <= 60; d++) {
  var id = 'RACK-' + (d < 10 ? '0' + d : d)
  // Most racks idle in the low 40s; RACK-27 is running away.
  var hot = d === 27
  deviceSeries.push({
    name: 'Temp',
    device: id,
    data: dayOfReadings(d * 13, hot ? 68 : 40 + (d % 7), hot ? 0.35 : 0),
  })
}

export default {
  components: {
    apexchart: VueApexCharts,
  },
  data: function () {
    return {
      series: deviceSeries,
      chartOptions: {
        chart: {
          id: 'deviceHealthTrellis',
          type: 'line',
          renderer: 'canvas',
        },
        trellis: {
          by: 'device',
          virtualize: true,
          panelHeight: 150,
          minPanelWidth: 240,
          gap: 12,
        },
        colors: ['#059669'],
        stroke: {
          width: 2,
          curve: 'straight',
        },
        xaxis: {
          type: 'datetime',
        },
        yaxis: {
          labels: {
            formatter: function (val) {
              return Math.round(val) + '°C'
            },
          },
        },
        dataLabels: {
          enabled: false,
        },
        tooltip: {
          x: {
            format: 'HH:mm',
          },
        },
      },
    }
  },
}
</script>

<style>
body {
  font-family:
    -apple-system, BlinkMacSystemFont, 'Segoe UI', Roboto, sans-serif;
  background: #fafbfc;
  color: #2c3e50;
  margin: 0;
  padding: 32px 16px;
}
.wrap {
  max-width: 1040px;
  margin: 0 auto;
}
h1 {
  font-size: 22px;
  margin: 0 0 8px;
}
.lead {
  color: #5b6b78;
  line-height: 1.5;
  margin: 0 0 20px;
}
.chart-wrap {
  background: #fff;
  border-radius: 8px;
  padding: 16px;
  box-shadow: 0 2px 10px rgba(0, 0, 0, 0.04);
}
.note {
  background: #ecfdf5;
  border-left: 3px solid #059669;
  padding: 12px 16px;
  font-size: 13px;
  color: #333;
  border-radius: 2px;
  line-height: 1.6;
  margin: 26px auto 0;
}
.note code {
  background: #d1fae5;
  padding: 1px 5px;
  border-radius: 3px;
}
</style>